MPI_Type_create_subarray(3)

NAME
MPI_Type_create_subarray - Create a datatype for a subarray of a regular, multidimensional array

SYNOPSIS
int MPI_Type_create_subarray(int ndims,
                           int array_of_sizes[],
                           int array_of_subsizes[],
                           int array_of_starts[],
                           int order,
                           MPI_Datatype oldtype,
                           MPI_Datatype *newtype)

INPUT PARAMETERS
ndims
    - number of array dimensions (positive integer)
array_of_sizes
    - number of elements of type oldtype in each dimension of the full array (array of positive integers)
array_of_subsizes
    - number of elements of type oldtype in each dimension of the subarray (array of positive integers)
array_of_starts
    - starting coordinates of the subarray in each dimension (array of nonnegative integers)
order
    - array storage order flag (state)
oldtype
    - array element datatype (handle)

OUTPUT PARAMETER
newtype
    - new datatype (handle)

THREAD AND INTERRUPT SAFETY
This routine is thread-safe. This means that this routine may be safely used by multiple threads without the need for any user-provided thread locks. However, the routine is not interrupt safe. Typically, this is due to the use of memory allocation routines such as malloc or other non-MPICH runtime routines that are themselves not interrupt-safe.

NOTES FOR FORTRAN
All MPI routines in Fortran (except for MPI_WTIME and MPI_WTICK ) have an additional argument ierr at the end of the argument list. ierr is an integer and has the same meaning as the return value of the routine in C. In Fortran, MPI routines are subroutines, and are invoked with the call statement. All MPI objects (e.g., MPI_Datatype , MPI_Comm ) are of type INTEGER in Fortran.

ERRORS
All MPI routines (except MPI_Wtime and MPI_Wtick ) return an error value; C routines as the value of the function and Fortran routines in the last argument. Before the value is returned, the current MPI error handler is called. By default, this error handler aborts the MPI job. The error handler may be changed with MPI_Comm_set_errhandler (for communicators), MPI_File_set_errhandler (for files), and MPI_Win_set_errhandler (for RMA windows). The MPI-1 routine MPI_Errhandler_set may be used but its use is deprecated. The predefined error handler MPI_ERRORS_RETURN may be used to cause error values to be returned. Note that MPI does not guarentee that an MPI program can continue past an error; however, MPI implementations will attempt to continue whenever possible.
MPI_SUCCESS
    - No error; MPI routine completed successfully.
MPI_ERR_TYPE
    - Invalid datatype argument. May be an uncommitted MPI_Datatype (see MPI_Type_commit ).
MPI_ERR_ARG
    - Invalid argument. Some argument is invalid and is not identified by a specific error class (e.g., MPI_ERR_RANK ).

LOCATION
type_create_subarray.c